#/bin/bash
#20220718
#Install driver and list card's information

EXAR_VID=13a8

#unbind PCIe-series device
PCIe_unbind=(`lspci -Dkn | grep $EXAR_VID | awk '{print $1}'`)				#PCIe domain numbers
Orig_driver=(`lspci -Dkn | grep -A 3 $EXAR_VID | grep "in use" | awk '{print $5}'`)	#unbind module

if [ -f xr17v35x.ko ]; then
	:
else
	echo xr17v35x.ko not exists.
	exit
fi

lsmod | grep xr17v35x > /dev/null
if [ $? == 0 ]; then
        echo "Driver already installed."
	exit
fi

#unbind from original driver
for ((index=0; index<${#PCIe_unbind[@]}; index++)); do
	if [ ${Orig_driver} ]; then
		echo -n ${PCIe_unbind[$index]} > /sys/bus/pci/drivers/${Orig_driver}/unbind #> /dev/null
	fi
done
	#install xr17v35x driver
        insmod xr17v35x.ko
        echo "Install driver OK!"

#List card's port information
for ((index=0; index<${#PCIe_unbind[@]}; index++)); do
		SVID_SDID=(`lspci -Dkn | grep -A 1 ${PCIe_unbind[$index]} | grep Subsystem | awk '{print $2}'`)
		case "$SVID_SDID" in
			1441:0080 ) echo -n "PCIe-S112 mode 232, "
					PORT=1;;
			1440:0080 ) echo -n "PCIe-S142 mode 485, "
					PORT=1;;
			1441:0091 ) echo -n "PCIe-S114 mode 232, "
					PORT=3;;
			1440:0091 ) echo -n "PCIe-S144 mode 485, "
					PORT=3;;
			1441:00a0 ) echo -n "PCIe-S118 mode 232, "
					PORT=7;;
			1440:00a0 ) echo -n "PCIe-S148 mode 485, "
					PORT=7;;
		esac

		NUM=`ls /sys/bus/pci/drivers/xrserial/${PCIe_unbind[$index]}/tty | head -n 1 | cut -c 6`
		NUM_end=$(($NUM + $PORT))
		echo ttyXR$NUM to ttyXR$NUM_end
done
